variables:
  coverage: false

pr: ['master', '3.9', '3.8', '3.7']

jobs:
- job: Prebuild
  displayName: Pre-build checks

  pool:
    vmImage: ubuntu-18.04

  steps:
  - template: ./prebuild-checks.yml


- job: Docs_PR
  displayName: Docs PR
  dependsOn: Prebuild
  condition: and(succeeded(), eq(dependencies.Prebuild.outputs['docs.run'], 'true'))

  pool:
    vmImage: ubuntu-18.04

  steps:
  - template: ./docs-steps.yml


- job: macOS_PR_Tests
  displayName: macOS PR Tests
  dependsOn: Prebuild
  #condition: and(succeeded(), eq(dependencies.Prebuild.outputs['tests.run'], 'true'))
  # bpo-39837: macOS tests on Azure Pipelines are disabled
  condition: false

  variables:
    testRunTitle: '$(system.pullRequest.TargetBranch)-macos'
    testRunPlatform: macos

  pool:
    vmImage: macos-10.14

  steps:
  - template: ./macos-steps.yml
    parameters:
      targetBranch: $(System.PullRequest.TargetBranch)


- job: Ubuntu_PR_Tests
  displayName: Ubuntu PR Tests
  dependsOn: Prebuild
  condition: and(succeeded(), eq(dependencies.Prebuild.outputs['tests.run'], 'true'))

  pool:
    vmImage: ubuntu-18.04

  variables:
    testRunTitle: '$(system.pullRequest.TargetBranch)-linux'
    testRunPlatform: linux
    openssl_version: 1.1.1g

  steps:
  - template: ./posix-steps.yml
    parameters:
      dependencies: apt


- job: Ubuntu_Coverage_PR_Tests
  displayName: Ubuntu PR Tests (coverage)
  dependsOn: Prebuild
  condition: |
    and(
        and(
            succeeded(),
            eq(variables['coverage'], 'true')
        ),
        eq(dependencies.Prebuild.outputs['tests.run'], 'true')
    )

  pool:
    vmImage: ubuntu-18.04

  variables:
    testRunTitle: '$(Build.SourceBranchName)-linux-coverage'
    testRunPlatform: linux-coverage
    openssl_version: 1.1.1g

  steps:
  - template: ./posix-steps.yml
    parameters:
      dependencies: apt
      coverage: true


- job: Windows_PR_Tests
  displayName: Windows PR Tests
  dependsOn: Prebuild
  condition: and(succeeded(), eq(dependencies.Prebuild.outputs['tests.run'], 'true'))

  pool:
    vmImage: windows-2019

  strategy:
    matrix:
      win32:
        arch: win32
        buildOpt: '-p Win32'
        testRunTitle: '$(System.PullRequest.TargetBranch)-win32'
        testRunPlatform: win32
      win64:
        arch: amd64
        buildOpt: '-p x64'
        testRunTitle: '$(System.PullRequest.TargetBranch)-win64'
        testRunPlatform: win64
      winarm64:
        arch: arm64
        buildOpt: '-p arm64'
    maxParallel: 4

  steps:
  - template: ./windows-steps.yml
    parameters:
      targetBranch: $(System.PullRequest.TargetBranch)
